#! /usr/bin/env python3
import codecs
import os, sys, re
import string

# USAGE: python3 pac2smt.py <filename> <width>
# where
# <filename> points to the files <filename.var> and <filename.pac>
# <width> defines the inputbitwidth
#
# eg: python3 pac2smt.py nbtor2proof 2

command_line_args = sys.argv

if (len(command_line_args) != 5) :
  raise AttributeError("Input missing")

n=2*int(command_line_args[4])+3


  
varfile = command_line_args[1]
pacfile = command_line_args[2] 
outputfile = command_line_args[3]

f_out = open(outputfile,"w")

f_out.write("(set-logic QF_BV)\n\n")


f_var = open(varfile,"r")
var = f_var.read()
var = var.replace('\n','')
var = var.replace(' ','')
var = re.split('(\W)', var)

var = [x for x in var if not (x.isdigit()) and x != '*' and x != ',' and x != '-' and x != '+' and x != ';' and x != '']
var = set(var)

for v in var:
  f_out.write("(declare-fun " + v + " () (_ BitVec 1))\n")

#f_out.write("\n")
#f_out.write("(define-fun E ((a (_ BitVec 1))) (_ BitVec " +str(n)+ ") ((_ sign_extend "+str(n-1)+") a))\n\n")

f_out.write("(assert\n")


f_pac = open(pacfile,"r")
pac = f_pac.read()
pac = pac.replace('\n','')
pac = pac.replace(' ','')
pac = pac.split(';')
i = 0

for line in pac[:-1]:
  steps = re.split(',|:',line)
  
  for (poly, name) in zip(steps[1:4], ['v', 'w', 'p']) :
    v = poly.split('+')
    f_out.write("(let (($"+name+str(i)+" ")
    if(len(v) > 1): f_out.write("(bvadd ")
    for summand in v:
      prod = summand.split('*')
      if(len(prod) > 1): f_out.write("(bvand ")
      for factor in prod:
        if factor.isdigit(): f_out.write("#b"+str(factor)+" ")
        elif (factor.find('^2') != -1): 
          f_out.write("((_ sign_extend "+str(n-1)+") "+ str(factor[:factor.find('^2')]) + ") ")
        else: f_out.write("((_ sign_extend "+str(n-1)+") "+str(factor)+") ")
      if(len(prod) > 1): f_out.write(")")
      
    if(len(v) > 1): f_out.write(")")
    f_out.write("))\n")
  
 
  
  operand = 'bvmul'
  if steps[0] == '+':
    operand = 'bvadd'
    
  f_out.write("(let (($e"+str(i)+" (= ("+operand+" $v"+str(i)+" $w"+str(i)+") $p"+str(i)+")))\n\n")
  i = i+1


f_out.write("(not (and")
for j in range(i):
  f_out.write(" $e"+str(j))
f_out.write("))\n")

parenthesis = ")"*4*i
f_out.write(parenthesis+"\n")
f_out.write(")\n\n")


f_out.write("(check-sat)\n")
f_out.write("(exit)\n")
f_out.close()

