#!/bin/sh
path=$1
name=$2
size=$3
msg () {
  echo "run_DRUP.sh: $*"
}
msg "path:     $path"
msg "name:     $name"
msg "start:    `date`"

rewr=${name}_rewr.aig
miter=${name}_miter.cnf
spec=${name}.spec

polys=${name}.polys
pac=${name}.pac
bitpolys=${name}_bit.polys
bitpac=${name}_bit.pac
smt=${name}.smt
bitrewr=${name}_bitmiter.aig
bitmiter=${name}_bitmiter.cnf
combined=${name}_combined.cnf
drup=${name}.drup


# substitution ----------------------------------------------------------
  amulet/amulet -substitute $path $miter $rewr

# certify miter ----------------------------------------------------------
  cadical --unsat $miter

# certify ------------------------------------------------------
  amulet/amulet -certify $rewr $polys $pac $spec

# bitproof ------------------------------------------------------
  DRUP/pac2smt_preprocess.py $polys $pac $bitpolys $bitpac $size

# proof2smt ------------------------------------------------------
  DRUP/pac2smt.py  $bitpolys $bitpac $smt $size

# boolector ------------------------------------------------------
  boolector $smt -dai -dam -o $bitrewr

# aigtocnf ------------------------------------------------------
  aiger/aigtocnf $bitrewr $bitmiter

# combine cnfs ------------------------------------------------------
  DRUP/combinecnf.py  $miter $bitmiter $combined


# certify cnf ------------------------------------------------------
  cadical --unsat $combined $drup


 # certify cnf ------------------------------------------------------
  drat-trim $combined $drup

msg "end:      `date`"
