#!/bin/sh
path=$1
name=$2
msg () {
  echo "run_PAC.sh: $*"
}
msg "path:     $path"
msg "name:     $name"
msg "start:    `date`"

rewr=${name}_rewr.aig
miter=${name}_miter.cnf
mapping=${name}.mapping
polys=${name}.polys
pac=${name}.pac
spec=${name}.spec
origspec=${name}.origspec
origout=${name}.origout
newout=${name}.newout
equal=${name}.equal
trace=${name}.trace


# substitution ----------------------------------------------------------

  amulet/amulet -substitute $path $miter $rewr $mapping $polys $pac $origout $origspec

# picosat ------------------------------------------------------

  picosat $miter -T $trace

# drup2pac ------------------------------------------------------

  PAC/drup2dpac $miter $trace $polys $pac $equal


# certify ------------------------------------------------------

  amulet/amulet -certify $rewr $polys $pac $spec $mapping $newout


# matchspec ------------------------------------------------------

  PAC/matchspec $origout $newout $equal $spec $pac


# pactrim ------------------------------------------------------

  pactrim/pactrim $polys $pac $origspec



msg "end:      `date`"
